/// <reference types="@types/qs" />
import type { ValidatorType } from './Validator';
import type { AxiosInstance, Method, AxiosRequestConfig, AxiosResponse } from 'axios';
import type { IParseOptions } from 'qs';
declare class BaseService {
    errors: ValidatorType;
    parameters: Record<string, any>;
    endpoint: string;
    static $http: AxiosInstance;
    static $errorProperty: string;
    static $parsedQs: IParseOptions;
    constructor(endpoint: string, parameters: Record<string, any>);
    get $http(): AxiosInstance;
    get $errorProperty(): string;
    get $parsedQs(): IParseOptions;
    all<T = any>(): Promise<T>;
    find<T = any>(id: number | string): Promise<T>;
    post<T = any>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    store<T = any>(payload: any, config?: AxiosRequestConfig): Promise<T>;
    put<T = any>(id: any, payload?: any, config?: AxiosRequestConfig): Promise<T>;
    patch<T = any>(id: any, payload?: any, config?: AxiosRequestConfig): Promise<T>;
    update<T = any>(id: string | number, payload: any): Promise<T>;
    delete<T = any>(id: string | number): Promise<T>;
    remove<T = any>(id: string | number): Promise<T>;
    submit<T = any>(method: Method, param?: string | number, form?: any, config?: AxiosRequestConfig): Promise<T>;
    $submit<T = any>(method: Method, param?: string | number, form?: any, config?: AxiosRequestConfig): Promise<AxiosResponse<T, any>>;
    private __getParameterString;
    private static __validateRequestType;
    setParameters(parameters: Record<string, any>): this;
    setParameter(parameter: string, value?: any): this;
    removeParameters(parameters?: any[]): this;
    removeParameter(parameter: string): this;
    onFail(errors: Record<string, any>): void;
    beforeSubmit(): void;
    onSuccess(): void;
}
export default BaseService;
