"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.is = exports.isFile = exports.hasOwnProperty = exports.isArray = void 0;
function isArray(object) {
    return Object.prototype.toString.call(object) === '[object Array]';
}
exports.isArray = isArray;
function hasOwnProperty(obj, key) {
    if (!obj || !key)
        return false;
    return Object.prototype.hasOwnProperty.call(obj, key);
}
exports.hasOwnProperty = hasOwnProperty;
function isFile(object) {
    if (typeof window === 'undefined' || typeof File !== 'function' || typeof FileList !== 'function') {
        return false;
    }
    return object instanceof File || object instanceof FileList;
}
exports.isFile = isFile;
function is(errors, error) {
    return isArray(error) ? error.some((w) => is(errors, w)) : errors.includes(error);
}
exports.is = is;
